# coding: utf-8

"""
    VMLab Backend

    The VMLab Backend API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr, field_validator
from typing import Any, Optional
from typing_extensions import Annotated

from slices_bi_client.api_client import ApiClient, RequestSerialized
from slices_bi_client.api_response import ApiResponse
from slices_bi_client.rest import RESTResponseType


class PhoneHomeApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def resource_phone_home_apis_bi_slices_eu_v1alpha1_phone_home_resource_id_phone_home_secret_post(
        self,
        phone_home_secret: StrictStr,
        resource_id: Annotated[str, Field(strict=True)],
        fqdn: Optional[StrictStr],
        hostname: Optional[StrictStr],
        instance_id: Optional[StrictStr],
        pub_key_ecdsa: Optional[StrictStr],
        pub_key_ed25519: Optional[StrictStr],
        pub_key_rsa: Optional[StrictStr],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> object:
        """Resource Phone Home

        Store the phone home data for the resource in the manifest.  See https://cloudinit.readthedocs.io/en/latest/reference/modules.html#phone-home

        :param phone_home_secret: (required)
        :type phone_home_secret: str
        :param resource_id: (required)
        :type resource_id: str
        :param fqdn: (required)
        :type fqdn: str
        :param hostname: (required)
        :type hostname: str
        :param instance_id: (required)
        :type instance_id: str
        :param pub_key_ecdsa: (required)
        :type pub_key_ecdsa: str
        :param pub_key_ed25519: (required)
        :type pub_key_ed25519: str
        :param pub_key_rsa: (required)
        :type pub_key_rsa: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._resource_phone_home_apis_bi_slices_eu_v1alpha1_phone_home_resource_id_phone_home_secret_post_serialize(
            phone_home_secret=phone_home_secret,
            resource_id=resource_id,
            fqdn=fqdn,
            hostname=hostname,
            instance_id=instance_id,
            pub_key_ecdsa=pub_key_ecdsa,
            pub_key_ed25519=pub_key_ed25519,
            pub_key_rsa=pub_key_rsa,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '202': "object",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def resource_phone_home_apis_bi_slices_eu_v1alpha1_phone_home_resource_id_phone_home_secret_post_with_http_info(
        self,
        phone_home_secret: StrictStr,
        resource_id: Annotated[str, Field(strict=True)],
        fqdn: Optional[StrictStr],
        hostname: Optional[StrictStr],
        instance_id: Optional[StrictStr],
        pub_key_ecdsa: Optional[StrictStr],
        pub_key_ed25519: Optional[StrictStr],
        pub_key_rsa: Optional[StrictStr],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[object]:
        """Resource Phone Home

        Store the phone home data for the resource in the manifest.  See https://cloudinit.readthedocs.io/en/latest/reference/modules.html#phone-home

        :param phone_home_secret: (required)
        :type phone_home_secret: str
        :param resource_id: (required)
        :type resource_id: str
        :param fqdn: (required)
        :type fqdn: str
        :param hostname: (required)
        :type hostname: str
        :param instance_id: (required)
        :type instance_id: str
        :param pub_key_ecdsa: (required)
        :type pub_key_ecdsa: str
        :param pub_key_ed25519: (required)
        :type pub_key_ed25519: str
        :param pub_key_rsa: (required)
        :type pub_key_rsa: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._resource_phone_home_apis_bi_slices_eu_v1alpha1_phone_home_resource_id_phone_home_secret_post_serialize(
            phone_home_secret=phone_home_secret,
            resource_id=resource_id,
            fqdn=fqdn,
            hostname=hostname,
            instance_id=instance_id,
            pub_key_ecdsa=pub_key_ecdsa,
            pub_key_ed25519=pub_key_ed25519,
            pub_key_rsa=pub_key_rsa,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '202': "object",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def resource_phone_home_apis_bi_slices_eu_v1alpha1_phone_home_resource_id_phone_home_secret_post_without_preload_content(
        self,
        phone_home_secret: StrictStr,
        resource_id: Annotated[str, Field(strict=True)],
        fqdn: Optional[StrictStr],
        hostname: Optional[StrictStr],
        instance_id: Optional[StrictStr],
        pub_key_ecdsa: Optional[StrictStr],
        pub_key_ed25519: Optional[StrictStr],
        pub_key_rsa: Optional[StrictStr],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Resource Phone Home

        Store the phone home data for the resource in the manifest.  See https://cloudinit.readthedocs.io/en/latest/reference/modules.html#phone-home

        :param phone_home_secret: (required)
        :type phone_home_secret: str
        :param resource_id: (required)
        :type resource_id: str
        :param fqdn: (required)
        :type fqdn: str
        :param hostname: (required)
        :type hostname: str
        :param instance_id: (required)
        :type instance_id: str
        :param pub_key_ecdsa: (required)
        :type pub_key_ecdsa: str
        :param pub_key_ed25519: (required)
        :type pub_key_ed25519: str
        :param pub_key_rsa: (required)
        :type pub_key_rsa: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._resource_phone_home_apis_bi_slices_eu_v1alpha1_phone_home_resource_id_phone_home_secret_post_serialize(
            phone_home_secret=phone_home_secret,
            resource_id=resource_id,
            fqdn=fqdn,
            hostname=hostname,
            instance_id=instance_id,
            pub_key_ecdsa=pub_key_ecdsa,
            pub_key_ed25519=pub_key_ed25519,
            pub_key_rsa=pub_key_rsa,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '202': "object",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _resource_phone_home_apis_bi_slices_eu_v1alpha1_phone_home_resource_id_phone_home_secret_post_serialize(
        self,
        phone_home_secret,
        resource_id,
        fqdn,
        hostname,
        instance_id,
        pub_key_ecdsa,
        pub_key_ed25519,
        pub_key_rsa,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if phone_home_secret is not None:
            _path_params['phone_home_secret'] = phone_home_secret
        if resource_id is not None:
            _path_params['resource_id'] = resource_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        if fqdn is not None:
            _form_params.append(('fqdn', fqdn))
        if hostname is not None:
            _form_params.append(('hostname', hostname))
        if instance_id is not None:
            _form_params.append(('instance_id', instance_id))
        if pub_key_ecdsa is not None:
            _form_params.append(('pub_key_ecdsa', pub_key_ecdsa))
        if pub_key_ed25519 is not None:
            _form_params.append(('pub_key_ed25519', pub_key_ed25519))
        if pub_key_rsa is not None:
            _form_params.append(('pub_key_rsa', pub_key_rsa))
        # process the body parameter


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/x-www-form-urlencoded'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/apis/bi.slices.eu/v1alpha1/phone_home/{resource_id}/{phone_home_secret}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


