# coding: utf-8

"""
    VMLab Backend

    The VMLab Backend API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class BareMetalFlavorCreate(BaseModel):
    """
    New Bare Metal Flavor to be added.
    """ # noqa: E501
    cpu_cores: StrictInt = Field(description="CPU cores (per CPU socket)")
    cpu_model: StrictStr = Field(description="CPU model.")
    cpu_sockets: StrictInt = Field(description="CPU count (= CPU socket count)")
    cpu_threads: StrictInt = Field(description="CPU Threads (per CPU core)")
    description: StrictStr = Field(description="Description of this flavor")
    disk_mb: StrictInt = Field(description="The size of the root disk in MB.")
    flavor_type: Optional[StrictStr] = Field(default='baremetal', description="The type of flavor")
    friendly_name: Annotated[str, Field(min_length=2, strict=True, max_length=30)] = Field(description="User readable ID")
    gpu_model: Optional[StrictStr]
    network_interface_count: StrictInt = Field(description="Number of test network interfaces present. (There is always at least the 'control' interface)")
    ram_mib: StrictInt = Field(description="The amount of RAM in MiB")
    __properties: ClassVar[List[str]] = ["cpu_cores", "cpu_model", "cpu_sockets", "cpu_threads", "description", "disk_mb", "flavor_type", "friendly_name", "gpu_model", "network_interface_count", "ram_mib"]

    @field_validator('flavor_type')
    def flavor_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['baremetal']):
            raise ValueError("must be one of enum values ('baremetal')")
        return value

    @field_validator('friendly_name')
    def friendly_name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"[a-zA-Z0-9][a-zA-Z0-9._-]+", value):
            raise ValueError(r"must validate the regular expression /[a-zA-Z0-9][a-zA-Z0-9._-]+/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BareMetalFlavorCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if gpu_model (nullable) is None
        # and model_fields_set contains the field
        if self.gpu_model is None and "gpu_model" in self.model_fields_set:
            _dict['gpu_model'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BareMetalFlavorCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cpu_cores": obj.get("cpu_cores"),
            "cpu_model": obj.get("cpu_model"),
            "cpu_sockets": obj.get("cpu_sockets"),
            "cpu_threads": obj.get("cpu_threads"),
            "description": obj.get("description"),
            "disk_mb": obj.get("disk_mb"),
            "flavor_type": obj.get("flavor_type") if obj.get("flavor_type") is not None else 'baremetal',
            "friendly_name": obj.get("friendly_name"),
            "gpu_model": obj.get("gpu_model"),
            "network_interface_count": obj.get("network_interface_count"),
            "ram_mib": obj.get("ram_mib")
        })
        return _obj


