# coding: utf-8

"""
    VMLab Backend

    The VMLab Backend API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from slices_bi_client.models.link_impairment import LinkImpairment
from typing import Optional, Set
from typing_extensions import Self

class BareMetalLinkCreate(BaseModel):
    """
    Model representing the request for a Bare Metal link between resources.
    """ # noqa: E501
    best_effort: Optional[StrictBool] = False
    friendly_name: StrictStr
    impairment: Optional[List[LinkImpairment]] = None
    interswitch: Optional[StrictBool] = False
    link_multiplexing: Optional[StrictBool] = False
    network_id: StrictStr
    no_mac_learning: Optional[StrictBool] = False
    share_lan_name: Optional[StrictStr] = None
    type: Optional[StrictStr] = 'lan'
    vlan_tagging: Optional[StrictBool] = False
    __properties: ClassVar[List[str]] = ["best_effort", "friendly_name", "impairment", "interswitch", "link_multiplexing", "network_id", "no_mac_learning", "share_lan_name", "type", "vlan_tagging"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['lan', 'vlan', 'gre-tunnel', 'egre-tunnel']):
            raise ValueError("must be one of enum values ('lan', 'vlan', 'gre-tunnel', 'egre-tunnel')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BareMetalLinkCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in impairment (list)
        _items = []
        if self.impairment:
            for _item in self.impairment:
                if _item:
                    _items.append(_item.to_dict())
            _dict['impairment'] = _items
        # set to None if impairment (nullable) is None
        # and model_fields_set contains the field
        if self.impairment is None and "impairment" in self.model_fields_set:
            _dict['impairment'] = None

        # set to None if share_lan_name (nullable) is None
        # and model_fields_set contains the field
        if self.share_lan_name is None and "share_lan_name" in self.model_fields_set:
            _dict['share_lan_name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BareMetalLinkCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "best_effort": obj.get("best_effort") if obj.get("best_effort") is not None else False,
            "friendly_name": obj.get("friendly_name"),
            "impairment": [LinkImpairment.from_dict(_item) for _item in obj["impairment"]] if obj.get("impairment") is not None else None,
            "interswitch": obj.get("interswitch") if obj.get("interswitch") is not None else False,
            "link_multiplexing": obj.get("link_multiplexing") if obj.get("link_multiplexing") is not None else False,
            "network_id": obj.get("network_id"),
            "no_mac_learning": obj.get("no_mac_learning") if obj.get("no_mac_learning") is not None else False,
            "share_lan_name": obj.get("share_lan_name"),
            "type": obj.get("type") if obj.get("type") is not None else 'lan',
            "vlan_tagging": obj.get("vlan_tagging") if obj.get("vlan_tagging") is not None else False
        })
        return _obj


