"""VMLab Backend

The VMLab Backend API

The version of the OpenAPI document: 0.1.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Annotated, Any, ClassVar, Optional

from pydantic import BaseModel, ConfigDict, Field, field_validator
from typing_extensions import Self

from slices_bi_client.models.network_interface_create import NetworkInterfaceCreate


class ComputeResourceCreate(BaseModel):
    """Request for a new Compute Resource."""  # noqa: E501

    disk_image_id: Annotated[str, Field(strict=True)] = Field(
        description="The ID of the image to use for this server instance"
    )
    flavor_id: Annotated[str, Field(strict=True)] = Field(description="The flavor reference")
    friendly_name: Annotated[str, Field(strict=True)] = Field(
        description="User readable name, must conform to the following rules: - Can only contain alphanumeric characters (a-z 0-9) or a minus sign (-) - Must be at least 2 characters long, cannot be longer than 63 characters - Must not start or end with a minus sign (-)"
    )
    network_interfaces: Optional[list[NetworkInterfaceCreate]] = None
    userdata: Optional[Annotated[str, Field(strict=True, max_length=1048576)]] = None
    __properties: ClassVar[list[str]] = [
        "disk_image_id",
        "flavor_id",
        "friendly_name",
        "network_interfaces",
        "userdata",
    ]

    @field_validator("disk_image_id")
    def disk_image_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"image_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /image_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("flavor_id")
    def flavor_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"flavor_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /flavor_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("friendly_name")
    def friendly_name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"[a-z0-9][a-z0-9-]{0,61}[a-z0-9]", value):
            raise ValueError(r"must validate the regular expression /[a-z0-9][a-z0-9-]{0,61}[a-z0-9]/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ComputeResourceCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in network_interfaces (list)
        _items = []
        if self.network_interfaces:
            for _item in self.network_interfaces:
                if _item:
                    _items.append(_item.to_dict())
            _dict["network_interfaces"] = _items
        # set to None if network_interfaces (nullable) is None
        # and model_fields_set contains the field
        if self.network_interfaces is None and "network_interfaces" in self.model_fields_set:
            _dict["network_interfaces"] = None

        # set to None if userdata (nullable) is None
        # and model_fields_set contains the field
        if self.userdata is None and "userdata" in self.model_fields_set:
            _dict["userdata"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ComputeResourceCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "disk_image_id": obj.get("disk_image_id"),
                "flavor_id": obj.get("flavor_id"),
                "friendly_name": obj.get("friendly_name"),
                "network_interfaces": [NetworkInterfaceCreate.from_dict(_item) for _item in obj["network_interfaces"]]
                if obj.get("network_interfaces") is not None
                else None,
                "userdata": obj.get("userdata"),
            }
        )
        return _obj
