"""VMLab Backend

The VMLab Backend API

The version of the OpenAPI document: 0.1.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Annotated, Any, ClassVar, Optional

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing_extensions import Self

from slices_bi_client.models.network_interface import NetworkInterface
from slices_bi_client.models.resource_state import ResourceState
from slices_bi_client.models.ssh_info import SSHInfo


class ComputeResourceCreateResult(BaseModel):
    """Result of a new Compute Resource create request."""  # noqa: E501

    cluster_id: StrictStr = Field(description="Cluster ID")
    console_url: Optional[Annotated[str, Field(min_length=1, strict=True)]] = None
    created_at: datetime = Field(description="Timestamp when this experiment was created")
    disk_image_id: Annotated[str, Field(strict=True)] = Field(
        description="The ID of the image to use for this server instance"
    )
    experiment_id: Annotated[str, Field(strict=True)] = Field(
        description="TypeID of an Experiment where this resource is a part of"
    )
    expires_at: Optional[datetime]
    flavor_id: Annotated[str, Field(strict=True)] = Field(description="The flavor reference")
    friendly_name: Annotated[str, Field(strict=True)] = Field(
        description="User readable name, must conform to the following rules: - Can only contain alphanumeric characters (a-z 0-9) or a minus sign (-) - Must be at least 2 characters long, cannot be longer than 63 characters - Must not start or end with a minus sign (-)"
    )
    id: Annotated[str, Field(strict=True)] = Field(description="TypeID uniquely identifying a resource")
    network_interfaces: list[NetworkInterface]
    private_ipv4: Optional[StrictStr]
    private_ipv6: Optional[StrictStr]
    public_ipv4: Optional[StrictStr]
    public_ipv6: Optional[StrictStr]
    ssh_authorized_keys: Optional[list[StrictStr]] = Field(
        default=None, description="Public SSH Keys that can login to the resource."
    )
    ssh_logins: Optional[list[SSHInfo]] = Field(default=None, description="SSH Logins for this resource.")
    status: ResourceState
    task_id: StrictStr
    terminated_at: Optional[datetime]
    userdata: Optional[StrictStr] = None
    __properties: ClassVar[list[str]] = [
        "cluster_id",
        "console_url",
        "created_at",
        "disk_image_id",
        "experiment_id",
        "expires_at",
        "flavor_id",
        "friendly_name",
        "id",
        "network_interfaces",
        "private_ipv4",
        "private_ipv6",
        "public_ipv4",
        "public_ipv6",
        "ssh_authorized_keys",
        "ssh_logins",
        "status",
        "task_id",
        "terminated_at",
        "userdata",
    ]

    @field_validator("disk_image_id")
    def disk_image_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"image_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /image_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("experiment_id")
    def experiment_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"exp_[a-z][a-z0-9.-]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /exp_[a-z][a-z0-9.-]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("flavor_id")
    def flavor_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"flavor_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /flavor_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("friendly_name")
    def friendly_name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"[a-z0-9][a-z0-9-]{0,61}[a-z0-9]", value):
            raise ValueError(r"must validate the regular expression /[a-z0-9][a-z0-9-]{0,61}[a-z0-9]/")
        return value

    @field_validator("id")
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"r_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /r_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ComputeResourceCreateResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in network_interfaces (list)
        _items = []
        if self.network_interfaces:
            for _item in self.network_interfaces:
                if _item:
                    _items.append(_item.to_dict())
            _dict["network_interfaces"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in ssh_logins (list)
        _items = []
        if self.ssh_logins:
            for _item in self.ssh_logins:
                if _item:
                    _items.append(_item.to_dict())
            _dict["ssh_logins"] = _items
        # set to None if console_url (nullable) is None
        # and model_fields_set contains the field
        if self.console_url is None and "console_url" in self.model_fields_set:
            _dict["console_url"] = None

        # set to None if expires_at (nullable) is None
        # and model_fields_set contains the field
        if self.expires_at is None and "expires_at" in self.model_fields_set:
            _dict["expires_at"] = None

        # set to None if private_ipv4 (nullable) is None
        # and model_fields_set contains the field
        if self.private_ipv4 is None and "private_ipv4" in self.model_fields_set:
            _dict["private_ipv4"] = None

        # set to None if private_ipv6 (nullable) is None
        # and model_fields_set contains the field
        if self.private_ipv6 is None and "private_ipv6" in self.model_fields_set:
            _dict["private_ipv6"] = None

        # set to None if public_ipv4 (nullable) is None
        # and model_fields_set contains the field
        if self.public_ipv4 is None and "public_ipv4" in self.model_fields_set:
            _dict["public_ipv4"] = None

        # set to None if public_ipv6 (nullable) is None
        # and model_fields_set contains the field
        if self.public_ipv6 is None and "public_ipv6" in self.model_fields_set:
            _dict["public_ipv6"] = None

        # set to None if terminated_at (nullable) is None
        # and model_fields_set contains the field
        if self.terminated_at is None and "terminated_at" in self.model_fields_set:
            _dict["terminated_at"] = None

        # set to None if userdata (nullable) is None
        # and model_fields_set contains the field
        if self.userdata is None and "userdata" in self.model_fields_set:
            _dict["userdata"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ComputeResourceCreateResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "cluster_id": obj.get("cluster_id"),
                "console_url": obj.get("console_url"),
                "created_at": obj.get("created_at"),
                "disk_image_id": obj.get("disk_image_id"),
                "experiment_id": obj.get("experiment_id"),
                "expires_at": obj.get("expires_at"),
                "flavor_id": obj.get("flavor_id"),
                "friendly_name": obj.get("friendly_name"),
                "id": obj.get("id"),
                "network_interfaces": [NetworkInterface.from_dict(_item) for _item in obj["network_interfaces"]]
                if obj.get("network_interfaces") is not None
                else None,
                "private_ipv4": obj.get("private_ipv4"),
                "private_ipv6": obj.get("private_ipv6"),
                "public_ipv4": obj.get("public_ipv4"),
                "public_ipv6": obj.get("public_ipv6"),
                "ssh_authorized_keys": obj.get("ssh_authorized_keys"),
                "ssh_logins": [SSHInfo.from_dict(_item) for _item in obj["ssh_logins"]]
                if obj.get("ssh_logins") is not None
                else None,
                "status": obj.get("status"),
                "task_id": obj.get("task_id"),
                "terminated_at": obj.get("terminated_at"),
                "userdata": obj.get("userdata"),
            }
        )
        return _obj
