# coding: utf-8

"""
    VMLab Backend

    The VMLab Backend API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class DiskImageCreate(BaseModel):
    """
    New Disk Image to be registered.
    """ # noqa: E501
    cluster_id: Optional[StrictStr] = Field(default='default', description="Cluster ID")
    default_username: Optional[StrictStr] = None
    friendly_name: Annotated[str, Field(min_length=3, strict=True, max_length=255)] = Field(description="User readable name")
    location: Optional[StrictStr] = None
    min_disk_mb: Optional[StrictInt] = None
    min_ram_mib: Optional[StrictInt] = None
    tags: Optional[List[StrictStr]] = None
    __properties: ClassVar[List[str]] = ["cluster_id", "default_username", "friendly_name", "location", "min_disk_mb", "min_ram_mib", "tags"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DiskImageCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if min_disk_mb (nullable) is None
        # and model_fields_set contains the field
        if self.min_disk_mb is None and "min_disk_mb" in self.model_fields_set:
            _dict['min_disk_mb'] = None

        # set to None if min_ram_mib (nullable) is None
        # and model_fields_set contains the field
        if self.min_ram_mib is None and "min_ram_mib" in self.model_fields_set:
            _dict['min_ram_mib'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DiskImageCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cluster_id": obj.get("cluster_id") if obj.get("cluster_id") is not None else 'default',
            "default_username": obj.get("default_username"),
            "friendly_name": obj.get("friendly_name"),
            "location": obj.get("location"),
            "min_disk_mb": obj.get("min_disk_mb"),
            "min_ram_mib": obj.get("min_ram_mib"),
            "tags": obj.get("tags")
        })
        return _obj


