# coding: utf-8

"""
    VMLab Backend

    The VMLab Backend API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from slices_bi_client.models.name_servers import NameServers
from slices_bi_client.models.route import Route
from typing import Optional, Set
from typing_extensions import Self

class NetworkInterfaceCreate(BaseModel):
    """
    A network interface describes a connection of a resource to a network.
    """ # noqa: E501
    addresses: Optional[List[StrictStr]] = None
    dhcp4: Optional[StrictBool] = None
    dhcp6: Optional[StrictBool] = None
    nameservers: Optional[NameServers] = None
    network_id: StrictStr = Field(description="ID of the network to which this interface is connected")
    port_id: StrictStr = Field(description="Name of the NIC to which this interface is coupled")
    routes: Optional[List[Route]] = None
    __properties: ClassVar[List[str]] = ["addresses", "dhcp4", "dhcp6", "nameservers", "network_id", "port_id", "routes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NetworkInterfaceCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of nameservers
        if self.nameservers:
            _dict['nameservers'] = self.nameservers.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in routes (list)
        _items = []
        if self.routes:
            for _item in self.routes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['routes'] = _items
        # set to None if addresses (nullable) is None
        # and model_fields_set contains the field
        if self.addresses is None and "addresses" in self.model_fields_set:
            _dict['addresses'] = None

        # set to None if dhcp4 (nullable) is None
        # and model_fields_set contains the field
        if self.dhcp4 is None and "dhcp4" in self.model_fields_set:
            _dict['dhcp4'] = None

        # set to None if dhcp6 (nullable) is None
        # and model_fields_set contains the field
        if self.dhcp6 is None and "dhcp6" in self.model_fields_set:
            _dict['dhcp6'] = None

        # set to None if nameservers (nullable) is None
        # and model_fields_set contains the field
        if self.nameservers is None and "nameservers" in self.model_fields_set:
            _dict['nameservers'] = None

        # set to None if routes (nullable) is None
        # and model_fields_set contains the field
        if self.routes is None and "routes" in self.model_fields_set:
            _dict['routes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NetworkInterfaceCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "addresses": obj.get("addresses"),
            "dhcp4": obj.get("dhcp4"),
            "dhcp6": obj.get("dhcp6"),
            "nameservers": NameServers.from_dict(obj["nameservers"]) if obj.get("nameservers") is not None else None,
            "network_id": obj.get("network_id"),
            "port_id": obj.get("port_id"),
            "routes": [Route.from_dict(_item) for _item in obj["routes"]] if obj.get("routes") is not None else None
        })
        return _obj


