# coding: utf-8

"""
    VMLab Backend

    The VMLab Backend API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from slices_bi_client.models.bare_metal_link_create import BareMetalLinkCreate
from slices_bi_client.models.compute_resource_create import ComputeResourceCreate
from slices_bi_client.models.token import Token
from typing import Optional, Set
from typing_extensions import Self

class NewResourcesRequest(BaseModel):
    """
    Request for new resources in a given experiment.
    """ # noqa: E501
    expires_at: datetime
    links: Optional[List[BareMetalLinkCreate]] = None
    resources: List[ComputeResourceCreate]
    ssh_authorized_keys: Annotated[List[StrictStr], Field(min_length=1)] = Field(description="SSH keys that are added to the default account of each server.")
    tokens: Optional[List[Token]] = None
    __properties: ClassVar[List[str]] = ["expires_at", "links", "resources", "ssh_authorized_keys", "tokens"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NewResourcesRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item in self.links:
                if _item:
                    _items.append(_item.to_dict())
            _dict['links'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in resources (list)
        _items = []
        if self.resources:
            for _item in self.resources:
                if _item:
                    _items.append(_item.to_dict())
            _dict['resources'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tokens (list)
        _items = []
        if self.tokens:
            for _item in self.tokens:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tokens'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NewResourcesRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "expires_at": obj.get("expires_at"),
            "links": [BareMetalLinkCreate.from_dict(_item) for _item in obj["links"]] if obj.get("links") is not None else None,
            "resources": [ComputeResourceCreate.from_dict(_item) for _item in obj["resources"]] if obj.get("resources") is not None else None,
            "ssh_authorized_keys": obj.get("ssh_authorized_keys"),
            "tokens": [Token.from_dict(_item) for _item in obj["tokens"]] if obj.get("tokens") is not None else None
        })
        return _obj


