# coding: utf-8

"""
    VMLab Backend

    The VMLab Backend API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SSHInfo(BaseModel):
    """
    Info about SSH Login to a resource.
    """ # noqa: E501
    description: Optional[StrictStr] = None
    host: StrictStr
    host_keys: Optional[List[StrictStr]] = Field(default=None, description="The public key(s) of the target SSH server, in openssh format. This list can be empty. It is recommended that it is not. The typical line you need to add to ~/.ssh/known_hosts is the host, a space, and then one of these keys.")
    jump_proxy: Optional[SSHInfo] = None
    port: StrictInt
    username: StrictStr
    __properties: ClassVar[List[str]] = ["description", "host", "host_keys", "jump_proxy", "port", "username"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SSHInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of jump_proxy
        if self.jump_proxy:
            _dict['jump_proxy'] = self.jump_proxy.to_dict()
        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if jump_proxy (nullable) is None
        # and model_fields_set contains the field
        if self.jump_proxy is None and "jump_proxy" in self.model_fields_set:
            _dict['jump_proxy'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SSHInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "description": obj.get("description"),
            "host": obj.get("host"),
            "host_keys": obj.get("host_keys"),
            "jump_proxy": SSHInfo.from_dict(obj["jump_proxy"]) if obj.get("jump_proxy") is not None else None,
            "port": obj.get("port"),
            "username": obj.get("username")
        })
        return _obj

# TODO: Rewrite to not use raise_errors
SSHInfo.model_rebuild(raise_errors=False)

