# coding: utf-8

"""
    VMLab Backend

    The VMLab Backend API

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class VMFlavorUpdate(BaseModel):
    """
    VM Flavor Update.
    """ # noqa: E501
    description: StrictStr = Field(description="Description of this flavor")
    disk_mb: StrictInt = Field(description="The size of the root disk that will be created in MB. If 0 the root disk will be set to exactly the size of the image used to deploy the instance.")
    flavor_type: Optional[StrictStr] = Field(default='vm', description="The type of flavor")
    friendly_name: Annotated[str, Field(min_length=2, strict=True, max_length=30)] = Field(description="User readable ID")
    ram_mib: StrictInt = Field(description="The amount of RAM in MiB")
    vcpus: StrictInt = Field(description="The number of virtual CPUs that will be allocated to the server")
    __properties: ClassVar[List[str]] = ["description", "disk_mb", "flavor_type", "friendly_name", "ram_mib", "vcpus"]

    @field_validator('flavor_type')
    def flavor_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['vm']):
            raise ValueError("must be one of enum values ('vm')")
        return value

    @field_validator('friendly_name')
    def friendly_name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"[a-zA-Z0-9][a-zA-Z0-9._-]+", value):
            raise ValueError(r"must validate the regular expression /[a-zA-Z0-9][a-zA-Z0-9._-]+/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VMFlavorUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VMFlavorUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "description": obj.get("description"),
            "disk_mb": obj.get("disk_mb"),
            "flavor_type": obj.get("flavor_type") if obj.get("flavor_type") is not None else 'vm',
            "friendly_name": obj.get("friendly_name"),
            "ram_mib": obj.get("ram_mib"),
            "vcpus": obj.get("vcpus")
        })
        return _obj


